乐筑天下

搜索
欢迎各位开发者和用户入驻本平台 尊重版权,从我做起,拒绝盗版,拒绝倒卖 签到、发布资源、邀请好友注册,可以获得银币 请注意保管好自己的密码,避免账户资金被盗
查看: 71|回复: 4

.NET有COM的CopyObjects吗?找到方法了!

[复制链接]

16

主题

53

帖子

1

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
117
发表于 2009-9-21 00:41:00 | 显示全部楼层 |阅读模式
com有object.CopyObjects(Objects[, Owner][, IDPairs]) ,object是, 用于将一个document的图形复制到另外一个document当中,而且在 CopyObjects 操作期间,被 Objects 参数中的源对象拥有或引用的对象也将被复制。
不知道.net有没有相同功能的函数?查看了对象浏览器的document和database对象,都没有类似的方法
回复

使用道具 举报

16

主题

53

帖子

1

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
117
发表于 2009-9-21 01:23:00 | 显示全部楼层
找到方法了!
使用WblockCloneObjects
注意红色的部分,不过不知道能不能复制块参照,并且把块参照的引用块定义也一起复制过去,com里的copyobjects方法可是可以做到这一点的,我试验过。

using Autodesk.AutoCAD.Runtime;using Autodesk.AutoCAD.ApplicationServices;using Autodesk.AutoCAD.DatabaseServices;using Autodesk.AutoCAD.Geometry;
[CommandMethod("CopyObjectsBetweenDatabases", CommandFlags.Session)]public static void CopyObjectsBetweenDatabases(){  ObjectIdCollection acObjIdColl = new ObjectIdCollection();
   // Get the current document and database  Document acDoc = Application.DocumentManager.MdiActiveDocument;  Database acCurDb = acDoc.Database;
   // Lock the current document  using (DocumentLock acLckDocCur = acDoc.LockDocument())  {      // Start a transaction      using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())      {          // Open the Block table record for read          BlockTable acBlkTbl;          acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,                                       OpenMode.ForRead) as BlockTable;
           // Open the Block table record Model space for write          BlockTableRecord acBlkTblRec;          acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],                                          OpenMode.ForWrite) as BlockTableRecord;
           // Create a circle that is at (0,0,0) with a radius of 5          Circle acCirc1 = new Circle();          acCirc1.SetDatabaseDefaults();          acCirc1.Center = new Point3d(0, 0, 0);          acCirc1.Radius = 5;
           // Add the new object to the block table record and the transaction          acBlkTblRec.AppendEntity(acCirc1);          acTrans.AddNewlyCreatedDBObject(acCirc1, true);
           // Create a circle that is at (0,0,0) with a radius of 7          Circle acCirc2 = new Circle();          acCirc2.SetDatabaseDefaults();          acCirc2.Center = new Point3d(0, 0, 0);          acCirc2.Radius = 7;
           // Add the new object to the block table record and the transaction          acBlkTblRec.AppendEntity(acCirc2);          acTrans.AddNewlyCreatedDBObject(acCirc2, true);
           // Add all the objects to copy to the new document          acObjIdColl = new ObjectIdCollection();          acObjIdColl.Add(acCirc1.ObjectId);          acObjIdColl.Add(acCirc2.ObjectId);
           // Save the new objects to the database          acTrans.Commit();      }
       // Unlock the document  }
   // Change the file and path to match a drawing template on your workstation  string sLocalRoot = Application.GetSystemVariable("LOCALROOTPREFIX") as string;  string sTemplatePath = sLocalRoot + "Template\\acad.dwt";
   // Create a new drawing to copy the objects to  DocumentCollection acDocMgr = Application.DocumentManager;  Document acNewDoc = acDocMgr.Add(sTemplatePath);  Database acDbNewDoc = acNewDoc.Database;
   // Lock the new document  using (DocumentLock acLckDoc = acNewDoc.LockDocument())  {      // Start a transaction in the new database      using (Transaction acTrans = acDbNewDoc.TransactionManager.StartTransaction())      {          // Open the Block table for read          BlockTable acBlkTblNewDoc;          acBlkTblNewDoc = acTrans.GetObject(acDbNewDoc.BlockTableId,                                             OpenMode.ForRead) as BlockTable;
           // Open the Block table record Model space for read          BlockTableRecord acBlkTblRecNewDoc;          acBlkTblRecNewDoc = acTrans.GetObject(acBlkTblNewDoc[BlockTableRecord.ModelSpace],                                              OpenMode.ForRead) as BlockTableRecord;
           // Clone the objects to the new database          IdMapping acIdMap = new IdMapping();          acCurDb.WblockCloneObjects(acObjIdColl, acBlkTblRecNewDoc.ObjectId, acIdMap,                                     DuplicateRecordCloning.Ignore, false);
           // Save the copied objects to the database          acTrans.Commit();      }
       // Unlock the document  }
   // Set the new document current  acDocMgr.MdiActiveDocument = acNewDoc;}
回复

使用道具 举报

72

主题

2726

帖子

9

银币

社区元老

Rank: 75Rank: 75Rank: 75

铜币
3014
发表于 2009-9-21 09:28:00 | 显示全部楼层
还有深度Clone
db.DeepCloneObjects(...)
回复

使用道具 举报

16

主题

53

帖子

1

银币

初露锋芒

Rank: 3Rank: 3Rank: 3

铜币
117
发表于 2009-9-21 19:27:00 | 显示全部楼层
深度clone有什么不一样吗?
回复

使用道具 举报

72

主题

2726

帖子

9

银币

社区元老

Rank: 75Rank: 75Rank: 75

铜币
3014
发表于 2009-9-21 19:43:00 | 显示全部楼层
深层拷贝-复制数据
浅层拷贝-只复制引用
具体的要在使用的过程中去理解它
回复

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

  • 微信公众平台

  • 扫描访问手机版

  • 点击图片下载手机App

QQ|关于我们|小黑屋|乐筑天下 繁体中文

GMT+8, 2025-3-14 13:19 , Processed in 0.425788 second(s), 62 queries .

© 2020-2025 乐筑天下

联系客服 关注微信 帮助中心 下载APP 返回顶部 返回列表